#include <stdlib.h>

#define total 10
#define colon 201
#define ligne 301

struct ghost {
	struct ghost * back;
	struct ghost * next;
	int une;
	int clk;
	int col;
	int row;
	int pix;
	struct ghost * down,*up,*left,*right, *dleft, *dright, *uleft, *uright;
} ;

//==========================================================================
//==========================================================================
//============================= ghost ======================================
//==========================================================================
//==========================================================================

struct ghost * head;
struct ghost * tail;
struct ghost * ici;

/*
void loop(void)
{
			ici = head;
			while (ici->next != NULL)
			{
				...

				ici = ici->next;
			}
}
*/


void creer (void)
{
	if (tail == 0)
	{
		head = (struct ghost *) malloc(sizeof(struct ghost));
		head->back = NULL;
		head->next = NULL;
		tail = head;
	}
	tail->next = (struct ghost *) malloc(sizeof(struct ghost));
	tail->next->back = tail;
	tail->next->next = NULL;
	tail = tail->next;
	return;
}

void detruire (struct ghost * mort)
{
	if ((mort->back == head)||(mort->next == head))
	{
		return;
	}
	if ((mort == tail)||(mort == head))
	{
		if (mort == tail)
		{
			tail = mort->back;
			mort->back->next = NULL;
			free(mort);
		}
		if (mort == head)
		{
			head = mort->next;
			mort->next->back = NULL;
			free(mort);
		}
	} else {
		mort->back->next = mort->next;
		mort->next->back = mort->back;
		free(mort);
	}
}
//==========================================================================
//==========================================================================
//============================ matrix ======================================
//==========================================================================
//==========================================================================
struct ghost * matrix[colon][ligne];

void join_the_matrix(struct ghost * aspirant)
{
		if (matrix[aspirant->col][aspirant->row] == NULL)
		{	matrix[aspirant->col][aspirant->row] = aspirant;	
		} else {
			detruire(aspirant);
		}
}

void touch_the_matrix(struct ghost * toucher)
{
	if (toucher->row > 1)
	{	toucher->down = matrix[toucher->col][toucher->row-1];
	} else {	toucher->down = toucher;	}
	if (toucher->row < 299)
	{	toucher->up = matrix[toucher->col][toucher->row+1];
	} else {	toucher->up = toucher;	}
	if (toucher->col > 1)
	{	toucher->left = matrix[toucher->col-1][toucher->row];
	} else {	toucher->left = toucher;	}
	if (toucher->col < 199)
	{	toucher->right = matrix[toucher->col+1][toucher->row];
	} else {	toucher->right = toucher;	}
	if ((toucher->row > 1)&&(toucher->col > 1))
	{	toucher->dleft = matrix[toucher->col-1][toucher->row-1];
	} else {	toucher->dleft = toucher;	}
	if ((toucher->row < 299)&&(toucher->col > 1))
	{	toucher->uleft = matrix[toucher->col-1][toucher->row+1];
	} else {	toucher->uleft = toucher;	}
	if ((toucher->row > 1)&&(toucher->col < 199))
	{	toucher->dright = matrix[toucher->col+1][toucher->row-1];
	} else {	toucher->dright = toucher;	}
	if ((toucher->row < 299)&&(toucher->col < 199))
	{	toucher->uright = matrix[toucher->col+1][toucher->row+1];
	} else {	toucher->uright = toucher;	}
}

void go_down(struct ghost * mover)
{	if (mover->down == NULL)
	{	matrix[mover->col][mover->row] = NULL;
		matrix[mover->col][mover->row-1] = mover;
		mover->row -= 1;
	} else {matrix[mover->col][mover->row] = mover->down;
		matrix[mover->col][mover->row-1] = mover;
		mover->row -= 1;
		mover->down->row +=1;
	}
}

void go_up(struct ghost * mover)
{
	if (mover->up == NULL)
	{	matrix[mover->col][mover->row] = NULL;
		matrix[mover->col][mover->row+1] = mover;
		mover->row += 1;
	} else {matrix[mover->col][mover->row] = mover->up;
		matrix[mover->col][mover->row+1] = mover;
		mover->row += 1;
		mover->up->row -=1;
	}
}

void go_left(struct ghost * mover)
{
	if (mover->left == NULL)
	{	matrix[mover->col][mover->row] = NULL;
		matrix[mover->col-1][mover->row] = mover;
		mover->col -= 1;
	} else {
	}
}

void go_right(struct ghost * mover)
{
	if (mover->right == NULL)
	{	matrix[mover->col][mover->row] = NULL;
		matrix[mover->col+1][mover->row] = mover;
		mover->col += 1;
	} else {
	}
}

void go_dleft(struct ghost * mover)
{
	if (mover->dleft == NULL)
	{	matrix[mover->col][mover->row] = NULL;
		matrix[mover->col-1][mover->row-1] = mover;
		mover->row -= 1;
		mover->col -= 1;
	} else {
	}
}

void go_dright(struct ghost * mover)
{
	if (mover->dright == NULL)
	{	matrix[mover->col][mover->row] = NULL;
		matrix[mover->col+1][mover->row-1] = mover;
		mover->row -= 1;
		mover->col += 1;
	} else {
	}
}

//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//===========================  feng  =======================================
//===========================  shui  =======================================
//=========================== system =======================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================

void element(struct ghost * point)
{
	touch_the_matrix(point);

	switch (point->une)
	{
	//-------------------> earth
		//	the simple element
		case 1:
			if (point->down != point)	//it follow the gravity
			{if (point->down == NULL)	//only if nothing under
			{	go_down(point);
				break;		}}

            		if (point->dleft != point)	//it can go down left
			{if (point->dleft == NULL)
			{	go_dleft(point);
				break;		}}

            		if (point->dright != point)	//it can go down right
			{if (point->dright == NULL)
			{	go_dright(point);
				break;		}}
			point->clk += 1;
			break;
	//-------------------> water
		//	the tempered element
		case 2:
			if (point->down != point)	//if nothing under
			{if (point->down == NULL)	//it follow gravity
			{	go_down(point);
				break;		}}
                   
			if (point->left != point)	//else it go left
			{if (point->left == NULL)
			{	go_left(point);
				break;		}}
					
			if (point->right != point)	//or right
			{if (point->right == NULL)
			{	go_right(point);
				break;		}}

			if (point->up != point)		//in tha case it is
			{if (point->up != NULL)		//under sand particle
			{if (point->up->une == 1)	//it switch with it
			{	go_up(point);
				break;		}}}
			point->clk += 1;		
			break;
	//-------------------> wood
		//	;the variable element
		case 3:

			if (point->down != point)			//simple gravity code
			{if (point->down == NULL)
			{	go_down(point);
				break;
			} else {
				if (point->down->une == 2)		//if on water !!
				{	if (point->dleft != point)	//algus formation code
					{if (point->dleft != NULL)
					{if (point->dleft->une == 3)
					{	break;		}}}
					if (point->dright != point)
					{if (point->dright != NULL)
					{if (point->dright->une == 3)
					{	break;		}}}
				go_down(point);				//to prevent floating
				break;				}

				if (point->down->une == 4)		//if on metal
				{	point->une = 1;			//grass simply cant live
					break;		}		//then return to dust
				
				if (point->down->une == 1)
				{	point->clk += 1;	}
			}}

			if (point->up != point)				//this make sure
			{if (point->up != NULL)				//that grass stay
			{if (point->up->une == 1)			//on the top of
			{	go_up(point);				//the sand
				break;		}
			if (point->up->une == 2)
			{	
			}
			}}

			if ((point->left != point)&&(point->right != point))
			{
				if (point->left != NULL)		//this code make that
				{if (point->left->une == 2)		//water can wipe a part
				{if (point->right == NULL)		//of the grass if its
				{	go_right(point);		//under its way
					break;		}}}

				if (point->right != NULL)
				{if (point->right->une == 2)
				{if (point->left == NULL)
				{	go_left(point);
					break;		}}}
			}

			break;
	//-------------------> metal
		//	the stable element
		case 4:
			if (point->down != point)
			{if (point->down == NULL)
			{

				if (point->up != point)
				{if (point->up != NULL)
				{if (point->up->une == 4)
				{	break;		}}}
				if (point->uleft != point)
				{if (point->uleft != NULL)
				{if (point->uleft->une == 4)
				{	break;		}}}
				if (point->uright != point)
				{if (point->uright != NULL)
				{if (point->uright->une == 4)
				{	break;		}}}
				if (point->left != point)
				{if (point->left != NULL)
				{if (point->left->une == 4)
				{	break;		}}}
				if (point->right != point)
				{if (point->right != NULL)
				{if (point->right->une == 4)
				{	break;		}}}
				if (point->dleft != point)
				{if (point->dleft != NULL)
				{if (point->dleft->une == 4)
				{	break;		}}}
				if (point->dright != point)
				{if (point->dright != NULL)
				{if (point->dright->une == 4)
				{	break;		}}}
				if (point->down != point)
				{if (point->down != NULL)
				{if (point->down->une == 4)
				{	break;		}}}

				go_down(point);
				break;
			}}
			break;
	//------------------> fire
		//	the transformation element
		case 5:
				point->clk += 1;
				if (point->clk == 100)
				{	point->une = 1;			//that transform fire
					point->pix = 0x00007700;	//into cinder ... curious
					break;		
				}

				if (point->up != point)	
				{if (point->up != NULL)	
				{
					//if (point->up->une == 4)		//it distabilise iron
					//{	go_up(point);
					//	break;		}
					if (point->up->une == 3)		//grass transform
					{	point->up->une = 5;		//into fire...
						point->up->pix = 0x00ff0000;}
					if (point->up->une == 2)		//reaction with water
					{	point->une = 1;			//that transform fire
						point->pix = 0x00007700;	//into cinder ... curious
						break;		}
					if (point->up->une == 1)
					{	point->une = 1;
						point->pix = 0x00007700;	//into cinder ... curious
						break;		}
				}}
				if (point->uleft != point)
				{if (point->uleft != NULL)
				{
					if (point->uleft->une == 3)
					{	point->uleft->une = 5;
						point->uleft->pix = 0x00ff0000;}
					if (point->uleft->une == 2)
					{	point->une = 1;
						point->pix = 0x00007700;
						break;		}
				}}
				if (point->uright != point)
				{if (point->uright != NULL)
				{
					if (point->uright->une == 3)
					{	point->uright->une = 5;
						point->uright->pix = 0x00ff0000;}
					if (point->uright->une == 2)
					{	point->une = 1;	
						point->pix = 0x00007700;
						break;		}
				}}
				if (point->left != point)
				{if (point->left != NULL)
				{
					if (point->left->une == 3)
					{	point->left->une = 5;
						point->left->pix = 0x00ff0000;}
					if (point->left->une == 2)
					{	point->une = 1;
						point->pix = 0x00007700;
						break;		}
				}}
				if (point->right != point)
				{if (point->right != NULL)
				{
					if (point->right->une == 3)
					{	point->right->une = 5;
						point->right->pix = 0x00ff0000;}
					if (point->right->une == 2)
					{	point->une = 1;
						point->pix = 0x00007700;
						break;		}
				}}
				if (point->dleft != point)
				{if (point->dleft != NULL)
				{
					if (point->dleft->une == 3)
					{	point->dleft->une = 5;
						point->dleft->pix = 0x00ff0000;}

					if (point->dleft->une == 2)
					{	point->une = 1;
						point->pix = 0x00007700;
						break;		}
				}}
				if (point->dright != point)
				{if (point->dright != NULL)
				{
					if (point->dright->une == 3)
					{	point->dright->une = 5;
						point->dright->pix = 0x00ff0000;}
					if (point->dright->une == 2)
					{	point->une = 1;
						point->pix = 0x00007700;
						break;		}
				}}
				if (point->down != point)
				{if (point->down != NULL)
				{
					if (point->down->une == 3)
					{	point->down->une = 5;
						point->down->pix = 0x00ff0000;}
					if (point->down->une == 2)
					{	point->une = 1;
						point->pix = 0x00007700;;
						break;		}
				} else {
					go_down(point);
					break;
				}}

			break;
	//----------------------------end
	}
//=========================================================================
//===================== why do i have problem ? ============================
//=========================================================================

}

//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
